/**
 * This is just an example - it doesn't do anything useful,
 * except show how to use try...catch and throw.
 * Remember, if a method CAN throw an exception, anyone 
 * calling it must either handle the exception, using 
 * try...catch, or else indicate that it
 * (the calling method) can itself throw that same exception,
 * using the "throws xyzException" modifier on the method declaration.
 * <br>
 * To run from the command line, "java -classpath . ExceptionExample" (which will
 * cause execution to start in method main() below).
 */
class ExceptionExample {
  /**
   * Provides some try/catch code to experiment with.
   * @param b true if firstMethod should throw an exception.
   */
  public void firstMethod(boolean b) {
    try {
      if (b)
        throw new FrammisException("There's trouble in firstMethod().");
      secondMethod(true);
    } catch (FrammisException e) {
      System.out.println("firstMethod: Caught exception: " + e.getMessage());
    } finally {
      System.out.println("firstMethod: Done with try..catch block");
    }
  }
  /**
   * Try removing "throws FrammisException".  You'll get a compile time error
   * because then secondMethod() neither handles nor admits to throwing
   * a FrammisException.
   * @param b true if secondMethod should throw an exception.
   */
  public void secondMethod(boolean b) throws FrammisException {
    if (b)
      throw new FrammisException("There's trouble in secondMethod()");
  }
  /**
   * Run the various methods.
   * @param args ignored
   */
  public static void main(String args[]) throws FrammisException {
    ExceptionExample ex = new ExceptionExample();
    ex.firstMethod(true);
    ex.secondMethod(true);
  }
}
